// Dfinition de la classe CPersonnage
// Cre par Etienne Forest le 28 aot 2012
// Adapte  SFML par Etienne Forest le 11 mars 2014
// Un CPersonnage est reprsent par une image  une certaine position dans une fentre.
// Il peut s'afficher dans la fentre qu'on lui passe.
#pragma once
#include <SFML/Graphics.hpp>
#include <string>
using namespace std;
using namespace sf;

class CPersonnage
{
private:
	Sprite Sprite_; // L'image qui reprsente le personnage
public:
	// Constructeur et destructeur
	// Le sprite conserve en fait un pointeur vers la texture, d'o l'importance de la rfrence
	CPersonnage(Texture& LaTexture, float PosX, float PosY) : Sprite_(LaTexture) { SetPosition(PosX, PosY); }
	~CPersonnage() { }

	// Accesseurs
	float GetPosX() const { return GetImage().getPosition().x; }
	float GetPosY() const { return GetImage().getPosition().y; }
	const Sprite& GetImage() const { return Sprite_; }

	// Mutateur
	// Accepte de modifier la position si elle ne sort pas de la fentre
	// (en fonction de LARGEUR et HAUTEUR dans Exercice3.7.h et des dimensions de l'image)
	// Retourne true si la position a chang, false sinon
	bool SetPosition(float x, float y);

	// Mthode
	// Affiche l'image du personnage  la position dans la fentre reue en rfrence
	void Afficher(RenderWindow& Fenetre);
};