// Le main est fourni dans l'nonc, ainsi que les enttes et descriptions des fonctions globales.
// Le corps des fonctions a t cr par Etienne Forest le 5 septembre 2012
// Modifi par Etienne Forest le 29 mars 2014 pour utiliser SFML au lieu de SDL
#include <SFML/Graphics.hpp>
#include "Exercice4.8.h"
#include "Sou.h"
using namespace sf;

/////////////////////////////////////////////////////////////////////////////
// InitialiserSous
//
// La fonction initialise un tableau de pointeurs de CSou
// en allouant dynamiquement un nouveau sou pour chaque
// case du tableau. La position initiale du sou est dtermine
// alatoirement.
// Intrants:
//   Tableau de pointeurs de CSou
//   Taille du tableau
//   Rfrence  une texture  utiliser pour les sous
/////////////////////////////////////////////////////////////////////////////
void InitialiserSous(CSou* Tableau[], int Taille, Texture& SouImg)
{
	for (int i = 0; i < Taille; i++)
	{
		Tableau[i] = new CSou(SouImg, rand() % Largeur, rand() % Hauteur);
	}
}

/////////////////////////////////////////////////////////////////////////////
// DeplacerSous
//
// Pour chaque case du tableau, la fonction vrifie si le pointeur 
// n'est pas zro. Si le pointeur n'est pas zro, le sou est dplac 
// vers le bas. Si le dplacement est impossible, le sou doit tre dtruit 
// et le pointeur doit tre mis  zro.
// Intrants:
//   Tableau de pointeurs de CSou
//   Taille du tableau
/////////////////////////////////////////////////////////////////////////////
void DeplacerSous(CSou* Tableau[], int Taille)
{
	for (int i = 0; i < Taille; i++)
	{
		if (Tableau[i] != nullptr)
		{
			if (!Tableau[i]->Deplacer())
			{
				delete Tableau[i];
				Tableau[i] = nullptr;
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// EncoreDesSous
//
// La fonction vrifie s'il y a au moins encore un sou dans le tableau.
// Pour ce faire, elle vrifie si au moins une case n'est pas zro.
// Intrants:
//   Tableau de pointeurs de CSou
//   Taille du tableau
// Extrant: Vrai s'il y a encore au moins un sou dans le tableau,
//          faux s'il n'y a plus aucun sou dans le tableau.
/////////////////////////////////////////////////////////////////////////////
bool EncoreDesSous(CSou* Tableau[], int Taille)
{
	bool Resultat = false;

	for (int i = 0; i < Taille && !Resultat; i++)
	{
		if (Tableau[i] != nullptr)
		{
			Resultat = true;
		}
	}
	return Resultat;
}

/////////////////////////////////////////////////////////////////////////////
// AfficherSous
//
// Pour chaque case du tableau, la fonction vrifie si le pointeur 
// n'est pas zro. Si le pointeur n'est pas zro, le sou est affich 
// dans la fentre.
// Intrants:
//   Tableau de pointeurs de CSou
//   Taille du tableau
//   Fenetre
/////////////////////////////////////////////////////////////////////////////
void AfficherSous(CSou* Tableau[], int Taille, RenderWindow& Fenetre)
{
	for (int i = 0; i < Taille; i++)
	{
		if (Tableau[i] != nullptr)
		{
			Tableau[i]->Afficher(Fenetre);
		}
	}
}

// Main fourni
int main(int argc, char *argv[])
{
	const int NBSOUS = 100;
	CSou* Sous[NBSOUS];
	Texture FondImg;
	Texture SouImg;
	SouImg.loadFromFile("sou.png");

	srand(static_cast<int>(time(0)));  // Pour initialiser le random

	RenderWindow Fenetre(VideoMode(Hauteur, Largeur), "L'argent tombe du ciel!");
	if (!FondImg.loadFromFile("fondmario.bmp"))
	{
		return EXIT_FAILURE;
	}
	Sprite Fond(FondImg); // Crer un sprite avec la texture du fond

	InitialiserSous(Sous, NBSOUS, SouImg);

	while (EncoreDesSous(Sous, NBSOUS))
	{
		Fenetre.clear();
		Fenetre.draw(Fond);
		AfficherSous(Sous, NBSOUS, Fenetre);
		DeplacerSous(Sous, NBSOUS);
		Fenetre.display();
		sleep(milliseconds(5));
	}

	return 0;
}